## com.gargoylesoftware.htmlunit.html
Class HtmlAnchor

    java.lang.Object
      com.gargoylesoftware.htmlunit.html.DomNode
          com.gargoylesoftware.htmlunit.html.DomNamespaceNode
              com.gargoylesoftware.htmlunit.html.DomElement
                  com.gargoylesoftware.htmlunit.html.HtmlElement
                      com.gargoylesoftware.htmlunit.html.StyledElement
                          com.gargoylesoftware.htmlunit.html.ClickableElement
                              com.gargoylesoftware.htmlunit.html.HtmlAnchor

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, org.w3c.dom.Element, org.w3c.dom.Node

    public class HtmlAnchor

extends ClickableElement

Wrapper for the HTML element "a".

Version:
  $Revision: 4789 $
Author:
  Mike Bowler, David K. Taylor, Christian Sell, Ahmed Ashour, Dmitri Zoubkov
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class com.gargoylesoftware.htmlunit.html.HtmlElement
`HtmlElement.ChildElementsIterator`

Nested classes/interfaces inherited from class com.gargoylesoftware.htmlunit.html.DomNode
`DomNode.ChildIterator, DomNode.DescendantElementsIterator`

Field Summary
`static java.lang.String` `TAG_NAME` The HTML tag represented by this element.

Fields inherited from class com.gargoylesoftware.htmlunit.html.HtmlElement
`TAB_INDEX_OUT_OF_BOUNDS`

Fields inherited from class com.gargoylesoftware.htmlunit.html.DomElement
`ATTRIBUTE_NOT_DEFINED, ATTRIBUTE_VALUE_EMPTY`

Fields inherited from class com.gargoylesoftware.htmlunit.html.DomNode
`AS_TEXT_BLANK, AS_TEXT_BLOCK_SEPARATOR, AS_TEXT_NEW_LINE, AS_TEXT_TAB, PROPERTY_ELEMENT, READY_STATE_COMPLETE, READY_STATE_INTERACTIVE, READY_STATE_LOADED, READY_STATE_LOADING, READY_STATE_UNINITIALIZED`

Fields inherited from interface org.w3c.dom.Node

`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Method Summary
`protected Page` `doClickAction(Page defaultPage)` This method will be called if there either wasn't an `onclick` handler, or there was but the result of that handler was `true`.
`protected Page` `doClickAction(Page defaultPage, java.lang.String hrefSuffix)` Same as `doClickAction(Page)`, except that it accepts an href suffix, needed when a click is performed on an image map to pass information on the click position.
`java.lang.String` `getAccessKeyAttribute()` Returns the value of the attribute "accesskey".
`java.lang.String` `getCharsetAttribute()` Returns the value of the attribute "charset".
`java.lang.String` `getCoordsAttribute()` Returns the value of the attribute "coords".
`java.lang.String` `getHrefAttribute()` Returns the value of the attribute "href".
`java.lang.String` `getHrefLangAttribute()` Returns the value of the attribute "hreflang".
`java.lang.String` `getNameAttribute()` Returns the value of the attribute "name".
`java.lang.String` `getOnBlurAttribute()` Returns the value of the attribute "onblur".
`java.lang.String` `getOnFocusAttribute()` Returns the value of the attribute "onfocus".
`java.lang.String` `getRelAttribute()` Returns the value of the attribute "rel".
`java.lang.String` `getRevAttribute()` Returns the value of the attribute "rev".
`java.lang.String` `getShapeAttribute()` Returns the value of the attribute "shape".
`java.lang.String` `getTabIndexAttribute()` Returns the value of the attribute "tabindex".
`java.lang.String` `getTargetAttribute()` Returns the value of the attribute "target".
`java.lang.String` `getTypeAttribute()` Returns the value of the attribute "type".
`Page` `openLinkInNewWindow()` Open this link in a new window, much as web browsers do when you shift-click a link or use the context menu to open in a new window.

Methods inherited from class com.gargoylesoftware.htmlunit.html.StyledElement
`getClassAttribute, getIdAttribute, getStyleAttribute, getTitleAttribute`

Methods inherited from class com.gargoylesoftware.htmlunit.html.HtmlElement

`addHtmlAttributeChangeListener, appendChildIfNoneExists, blur, checkChildHierarchy, click, click, click, dblClick, dblClick, doType, fireEvent, fireEvent, fireHtmlAttributeAdded, fireHtmlAttributeRemoved, fireHtmlAttributeReplaced, focus, getChildElements, getElementById, getElementsByAttribute, getEnclosingElement, getEnclosingForm, getEnclosingFormOrDie, getEventHandler, getHtmlElementsByTagName, getHtmlElementsByTagNames, getId, getLangAttribute, getNodeName, getOnClickAttribute, getOnDblClickAttribute, getOneHtmlElementByAttribute, getOnKeyDownAttribute, getOnKeyPressAttribute, getOnKeyUpAttribute, getOnMouseDownAttribute, getOnMouseMoveAttribute, getOnMouseOutAttribute, getOnMouseOverAttribute, getOnMouseUpAttribute, getTabIndex, getTextDirectionAttribute, getXmlLangAttribute, hasHtmlElementWithId, isAttributeCaseSensitive, isStateUpdateFirst, isSubmittableByEnter, mouseDown, mouseDown, mouseMove, mouseMove, mouseOut, mouseOut, mouseOver, mouseOver, mouseUp, mouseUp, preventDefault, removeAttribute, removeChild, removeEventHandler, removeHtmlAttributeChangeListener, rightClick, rightClick, setAttributeNS, setEventHandler, setEventHandler, setId, toString, type, type, type, type`

Methods inherited from class com.gargoylesoftware.htmlunit.html.DomElement

`cloneNode, getAttribute, getAttributeNode, getAttributeNodeNS, getAttributeNS, getAttributes, getAttributesMap, getElementsByTagName, getElementsByTagNameNS, getNodeType, getSchemaTypeInfo, getTagName, hasAttribute, hasAttributeNS, hasAttributes, isEmptyXmlTagExpanded, namespaces, printOpeningTagContentAsXml, printXml, removeAttributeNode, removeAttributeNS, setAttribute, setAttributeNode, setAttributeNodeNS, setIdAttribute, setIdAttributeNode, setIdAttributeNS`

Methods inherited from class com.gargoylesoftware.htmlunit.html.DomNamespaceNode
`getLocalName, getNamespaceURI, getPrefix, getQualifiedName, setPrefix`

Methods inherited from class com.gargoylesoftware.htmlunit.html.DomNode

`addDomChangeListener, appendChild, asText, asXml, compareDocumentPosition, fireNodeAdded, fireNodeDeleted, getAllHtmlChildElements, getAncestors, getBaseURI, getByXPath, getCanonicalXPath, getChildNodes, getChildren, getEndColumnNumber, getEndLineNumber, getFeature, getFirstByXPath, getFirstChild, getLastChild, getNextSibling, getNodeValue, getOwnerDocument, getPage, getParentNode, getPreviousSibling, getReadyState, getScriptObject, getStartColumnNumber, getStartLineNumber, getTextContent, getUserData, hasChildNodes, insertBefore, insertBefore, isAncestorOf, isBlock, isDefaultNamespace, isDisplayed, isEqualNode, isSameNode, isSupported, isTrimmedText, lookupNamespaceURI, lookupPrefix, normalize, notifyIncorrectness, onAddedToPage, onAllChildrenAddedToPage, printChildrenAsXml, remove, removeAllChildren, removeChild, removeDomChangeListener, replace, replaceChild, selectNodes, selectSingleNode, setNextSibling, setNodeValue, setParentNode, setPreviousSibling, setReadyState, setScriptObject, setTextContent, setUserData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.w3c.dom.Node

`appendChild, compareDocumentPosition, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

Field Detail

### TAG_NAME

    public static final java.lang.String TAG_NAME

  The HTML tag represented by this element.

  See Also:
    Constant Field Values

Method Detail

### doClickAction

    protected Page doClickAction(Page defaultPage,
                                 java.lang.String hrefSuffix)
                          throws java.io.IOException

  Same as `doClickAction(Page)`, except that it accepts an href suffix, needed when a click is performed on an image map to pass information on the click position.

  Parameters:
    `defaultPage` - the default page to return if the action does not load a new page
    `hrefSuffix` - the suffix to add to the anchor's href attribute (for instance coordinates from an image map)
  Returns:
    the page that is currently loaded after execution of this method
  Throws:
    `java.io.IOException` - if an IO error occurs

### doClickAction

    protected Page doClickAction(Page defaultPage)
                          throws java.io.IOException

  This method will be called if there either wasn't an `onclick` handler, or there was but the result of that handler was `true`. This is the default behavior of clicking the element. For this anchor element, the default behavior is to open the HREF page, or execute the HREF if it is a `javascript:` URL.

  Overrides:
    `doClickAction` in class `HtmlElement`
  Parameters:
    `defaultPage` - the default page to return if the action does not load a new page
  Returns:
    the page that is currently loaded after execution of this method
  Throws:
    `java.io.IOException` - if an IO error occurs

### getCharsetAttribute

    public final java.lang.String getCharsetAttribute()

  Returns the value of the attribute "charset". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "charset" or an empty string if that attribute isn't defined

### getTypeAttribute

    public final java.lang.String getTypeAttribute()

  Returns the value of the attribute "type". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "type" or an empty string if that attribute isn't defined

### getNameAttribute

    public final java.lang.String getNameAttribute()

  Returns the value of the attribute "name". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "name" or an empty string if that attribute isn't defined

### getHrefAttribute

    public final java.lang.String getHrefAttribute()

  Returns the value of the attribute "href". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "href" or an empty string if that attribute isn't defined

### getHrefLangAttribute

    public final java.lang.String getHrefLangAttribute()

  Returns the value of the attribute "hreflang". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "hreflang" or an empty string if that attribute isn't defined

### getRelAttribute

    public final java.lang.String getRelAttribute()

  Returns the value of the attribute "rel". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "rel" or an empty string if that attribute isn't defined

### getRevAttribute

    public final java.lang.String getRevAttribute()

  Returns the value of the attribute "rev". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "rev" or an empty string if that attribute isn't defined

### getAccessKeyAttribute

    public final java.lang.String getAccessKeyAttribute()

  Returns the value of the attribute "accesskey". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "accesskey" or an empty string if that attribute isn't defined

### getShapeAttribute

    public final java.lang.String getShapeAttribute()

  Returns the value of the attribute "shape". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "shape" or an empty string if that attribute isn't defined

### getCoordsAttribute

    public final java.lang.String getCoordsAttribute()

  Returns the value of the attribute "coords". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "coords" or an empty string if that attribute isn't defined

### getTabIndexAttribute

    public final java.lang.String getTabIndexAttribute()

  Returns the value of the attribute "tabindex". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "tabindex" or an empty string if that attribute isn't defined

### getOnFocusAttribute

    public final java.lang.String getOnFocusAttribute()

  Returns the value of the attribute "onfocus". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "onfocus" or an empty string if that attribute isn't defined

### getOnBlurAttribute

    public final java.lang.String getOnBlurAttribute()

  Returns the value of the attribute "onblur". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "onblur" or an empty string if that attribute isn't defined

### getTargetAttribute

    public final java.lang.String getTargetAttribute()

  Returns the value of the attribute "target". Refer to the HTML 4.01 documentation for details on the use of this attribute.

  Returns:
    the value of the attribute "target" or an empty string if that attribute isn't defined

### openLinkInNewWindow

    public final Page openLinkInNewWindow()
                                   throws java.net.MalformedURLException

  Open this link in a new window, much as web browsers do when you shift-click a link or use the context menu to open in a new window. It should be noted that even web browsers will sometimes not give the expected result when using this method of following links. Links that have no real href and rely on JavaScript to do their work will fail.

  Returns:
    the page opened by this link, nested in a new `TopLevelWindow`
  Throws:
    `java.net.MalformedURLException` - if the href could not be converted to a valid URL

Copyright © 2002-2011 Gargoyle Software Inc.. All Rights Reserved.